<doxygen xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" version="1.8.13" xsi:noNamespaceSchemaLocation="compound.xsd">
  <compounddef id="cy__crypto__core__ecc__ecdsa_8c" kind="file" language="C++">
    <compoundname>cy_crypto_core_ecc_ecdsa.c</compoundname>
    <includes local="yes" refid="cy__crypto__core__ecc_8h">cy_crypto_core_ecc.h</includes>
    <includes local="yes" refid="cy__crypto__core__ecc__nist__p_8h">cy_crypto_core_ecc_nist_p.h</includes>
    <includes local="yes" refid="cy__crypto__core__mem_8h">cy_crypto_core_mem.h</includes>
    <includes local="yes" refid="cy__crypto__core__vu_8h">cy_crypto_core_vu.h</includes>
      <sectiondef kind="func">
      <memberdef const="no" explicit="no" id="group__group__crypto__lld__asymmetric__functions_1ga236266f9b1594f360024e6e97743f415" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type><ref kindref="member" refid="group__group__crypto__enums_1ga3a65158da3dc5cb6aa016ae599542aad">cy_en_crypto_status_t</ref></type>
        <definition>cy_en_crypto_status_t Cy_Crypto_Core_ECC_SignHash</definition>
        <argsstring>(CRYPTO_Type *base, const uint8_t *hash, uint32_t hashlen, uint8_t *sig, const cy_stc_crypto_ecc_key *key, const uint8_t *messageKey)</argsstring>
        <name>Cy_Crypto_Core_ECC_SignHash</name>
        <param>
          <type>CRYPTO_Type *</type>
          <declname>base</declname>
        </param>
        <param>
          <type>const uint8_t *</type>
          <declname>hash</declname>
        </param>
        <param>
          <type>uint32_t</type>
          <declname>hashlen</declname>
        </param>
        <param>
          <type>uint8_t *</type>
          <declname>sig</declname>
        </param>
        <param>
          <type>const <ref kindref="compound" refid="structcy__stc__crypto__ecc__key">cy_stc_crypto_ecc_key</ref> *</type>
          <declname>key</declname>
        </param>
        <param>
          <type>const uint8_t *</type>
          <declname>messageKey</declname>
        </param>
        <briefdescription>
<para>Sign a message digest. </para>        </briefdescription>
        <detaileddescription>
<para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername>base</parametername>
</parameternamelist>
<parameterdescription>
<para>The pointer to a Crypto instance.</para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername>hash</parametername>
</parameternamelist>
<parameterdescription>
<para>The message digest to sign. Provided as is in data buffer.</para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername>hashlen</parametername>
</parameternamelist>
<parameterdescription>
<para>The length of the digest in bytes.</para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername>sig</parametername>
</parameternamelist>
<parameterdescription>
<para>[out] The destination for the signature, 'r' followed by 's'.</para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername>key</parametername>
</parameternamelist>
<parameterdescription>
<para>Key used for signature generation. See <ref kindref="compound" refid="structcy__stc__crypto__ecc__key">cy_stc_crypto_ecc_key</ref>.</para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername>messageKey</parametername>
</parameternamelist>
<parameterdescription>
<para>Message key.</para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>status code. See <ref kindref="member" refid="group__group__crypto__enums_1ga3a65158da3dc5cb6aa016ae599542aad">cy_en_crypto_status_t</ref>. </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="222" bodyfile="/var/tmp/gitlab-runner1/builds/7e5c9300/0/repo/psoc6pdl/drivers/source/cy_crypto_core_ecc_ecdsa.c" bodystart="66" column="1" file="/var/tmp/gitlab-runner1/builds/7e5c9300/0/repo/psoc6pdl/drivers/source/cy_crypto_core_ecc_ecdsa.c" line="66" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__crypto__lld__asymmetric__functions_1ga1d1d01ef464f6609df2a5c1ba4186d86" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type><ref kindref="member" refid="group__group__crypto__enums_1ga3a65158da3dc5cb6aa016ae599542aad">cy_en_crypto_status_t</ref></type>
        <definition>cy_en_crypto_status_t Cy_Crypto_Core_ECC_VerifyHash</definition>
        <argsstring>(CRYPTO_Type *base, const uint8_t *sig, const uint8_t *hash, uint32_t hashlen, uint8_t *stat, const cy_stc_crypto_ecc_key *key)</argsstring>
        <name>Cy_Crypto_Core_ECC_VerifyHash</name>
        <param>
          <type>CRYPTO_Type *</type>
          <declname>base</declname>
        </param>
        <param>
          <type>const uint8_t *</type>
          <declname>sig</declname>
        </param>
        <param>
          <type>const uint8_t *</type>
          <declname>hash</declname>
        </param>
        <param>
          <type>uint32_t</type>
          <declname>hashlen</declname>
        </param>
        <param>
          <type>uint8_t *</type>
          <declname>stat</declname>
        </param>
        <param>
          <type>const <ref kindref="compound" refid="structcy__stc__crypto__ecc__key">cy_stc_crypto_ecc_key</ref> *</type>
          <declname>key</declname>
        </param>
        <briefdescription>
<para>Verify an ECC signature. </para>        </briefdescription>
        <detaileddescription>
<para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername>base</parametername>
</parameternamelist>
<parameterdescription>
<para>The pointer to a Crypto instance.</para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername>sig</parametername>
</parameternamelist>
<parameterdescription>
<para>The signature to verify, 'R' followed by 'S'.</para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername>hash</parametername>
</parameternamelist>
<parameterdescription>
<para>The hash (message digest) that was signed.</para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername>hashlen</parametername>
</parameternamelist>
<parameterdescription>
<para>The length of the hash (octets).</para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername>stat</parametername>
</parameternamelist>
<parameterdescription>
<para>Result of signature, 1==valid, 0==invalid.</para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername>key</parametername>
</parameternamelist>
<parameterdescription>
<para>The corresponding public ECC key. See <ref kindref="compound" refid="structcy__stc__crypto__ecc__key">cy_stc_crypto_ecc_key</ref>.</para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>status code. See <ref kindref="member" refid="group__group__crypto__enums_1ga3a65158da3dc5cb6aa016ae599542aad">cy_en_crypto_status_t</ref>. </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="438" bodyfile="/var/tmp/gitlab-runner1/builds/7e5c9300/0/repo/psoc6pdl/drivers/source/cy_crypto_core_ecc_ecdsa.c" bodystart="252" column="1" file="/var/tmp/gitlab-runner1/builds/7e5c9300/0/repo/psoc6pdl/drivers/source/cy_crypto_core_ecc_ecdsa.c" line="252" />
      </memberdef>
      </sectiondef>
    <briefdescription>
<para>This file provides constant and parameters for the API for the ECC ECDSA in the Crypto driver. </para>    </briefdescription>
    <detaileddescription>
<para><simplesect kind="version"><para>2.30.3</para></simplesect>
Copyright 2016-2020 Cypress Semiconductor Corporation SPDX-License-Identifier: Apache-2.0</para><para>Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with the License. You may obtain a copy of the License at</para><para><ulink url="http://www.apache.org/licenses/LICENSE-2.0">http://www.apache.org/licenses/LICENSE-2.0</ulink></para><para>Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License. </para>    </detaileddescription>
    <programlisting>
<codeline lineno="1"><highlight class="comment">/***************************************************************************/</highlight></codeline>
<codeline lineno="27"><highlight class="preprocessor">#include<sp />"cy_crypto_core_ecc.h"</highlight><highlight class="normal" /></codeline>
<codeline lineno="28"><highlight class="normal" /></codeline>
<codeline lineno="29"><highlight class="normal" /><highlight class="preprocessor">#if<sp />defined(CY_IP_MXCRYPTO)</highlight><highlight class="normal" /></codeline>
<codeline lineno="30"><highlight class="normal" /></codeline>
<codeline lineno="31"><highlight class="normal" /><highlight class="preprocessor">#if<sp />defined(__cplusplus)</highlight><highlight class="normal" /></codeline>
<codeline lineno="32"><highlight class="normal" /><highlight class="keyword">extern</highlight><highlight class="normal"><sp /></highlight><highlight class="stringliteral">"C"</highlight><highlight class="normal"><sp />{</highlight></codeline>
<codeline lineno="33"><highlight class="normal" /><highlight class="preprocessor">#endif</highlight><highlight class="normal" /></codeline>
<codeline lineno="34"><highlight class="normal" /></codeline>
<codeline lineno="35"><highlight class="normal" /><highlight class="preprocessor">#include<sp />"cy_crypto_core_ecc_nist_p.h"</highlight><highlight class="normal" /></codeline>
<codeline lineno="36"><highlight class="normal" /><highlight class="preprocessor">#include<sp />"cy_crypto_core_mem.h"</highlight><highlight class="normal" /></codeline>
<codeline lineno="37"><highlight class="normal" /><highlight class="preprocessor">#include<sp />"cy_crypto_core_vu.h"</highlight><highlight class="normal" /></codeline>
<codeline lineno="38"><highlight class="normal" /></codeline>
<codeline lineno="39"><highlight class="normal" /><highlight class="comment">/*******************************************************************************</highlight></codeline>
<codeline lineno="40"><highlight class="comment">*<sp />Function<sp />Name:<sp />Cy_Crypto_Core_ECC_SignHash</highlight></codeline>
<codeline lineno="41"><highlight class="comment">****************************************************************************/</highlight></codeline>
<codeline lineno="66"><highlight class="normal"><ref kindref="member" refid="group__group__crypto__enums_1ga3a65158da3dc5cb6aa016ae599542aad">cy_en_crypto_status_t</ref><sp /><ref kindref="member" refid="group__group__crypto__lld__asymmetric__functions_1ga236266f9b1594f360024e6e97743f415">Cy_Crypto_Core_ECC_SignHash</ref>(CRYPTO_Type<sp />*base,<sp /></highlight><highlight class="keyword">const</highlight><highlight class="normal"><sp />uint8_t<sp />*hash,<sp />uint32_t<sp />hashlen,<sp />uint8_t<sp />*sig,</highlight></codeline>
<codeline lineno="67"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keyword">const</highlight><highlight class="normal"><sp /><ref kindref="compound" refid="structcy__stc__crypto__ecc__key">cy_stc_crypto_ecc_key</ref><sp />*key,<sp /></highlight><highlight class="keyword">const</highlight><highlight class="normal"><sp />uint8_t<sp />*messageKey)</highlight></codeline>
<codeline lineno="68"><highlight class="normal">{</highlight></codeline>
<codeline lineno="69"><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__crypto__enums_1ga3a65158da3dc5cb6aa016ae599542aad">cy_en_crypto_status_t</ref><sp />tmpResult<sp />=<sp /><ref kindref="member" refid="group__group__crypto__enums_1gga3a65158da3dc5cb6aa016ae599542aada254861d7a75c5e292718d39dbbe84319">CY_CRYPTO_BAD_PARAMS</ref>;</highlight></codeline>
<codeline lineno="70"><highlight class="normal" /></codeline>
<codeline lineno="71"><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="compound" refid="structcy__stc__crypto__ecc__key">cy_stc_crypto_ecc_key</ref><sp />ephKey;</highlight></codeline>
<codeline lineno="72"><highlight class="normal"><sp /><sp /><sp /><sp />uint8_t<sp />myKGX[CY_CRYPTO_ECC_MAX_BYTE_SIZE];</highlight></codeline>
<codeline lineno="73"><highlight class="normal"><sp /><sp /><sp /><sp />uint8_t<sp />myKGY[CY_CRYPTO_ECC_MAX_BYTE_SIZE];</highlight></codeline>
<codeline lineno="74"><highlight class="normal" /></codeline>
<codeline lineno="75"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keyword">const</highlight><highlight class="normal"><sp /><ref kindref="compound" refid="structcy__stc__crypto__ecc__dp__type">cy_stc_crypto_ecc_dp_type</ref><sp />*eccDp;</highlight></codeline>
<codeline lineno="76"><highlight class="normal"><sp /><sp /><sp /><sp />uint32_t<sp />mallocMask<sp />=<sp />0U;</highlight></codeline>
<codeline lineno="77"><highlight class="normal" /></codeline>
<codeline lineno="78"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />NULL<sp />parameters<sp />checking<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="79"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />((hash<sp />!=<sp />NULL)<sp />&amp;&amp;<sp />(sig<sp />!=<sp />NULL)<sp />&amp;&amp;<sp />(key<sp />!=<sp />NULL)<sp />&amp;&amp;<sp />(messageKey<sp />!=<sp />NULL))</highlight></codeline>
<codeline lineno="80"><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="81"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />tmpResult<sp />=<sp /><ref kindref="member" refid="group__group__crypto__enums_1gga3a65158da3dc5cb6aa016ae599542aada3bba593d15daa1e8e07acd1c5d110af2">CY_CRYPTO_NOT_SUPPORTED</ref>;</highlight></codeline>
<codeline lineno="82"><highlight class="normal" /></codeline>
<codeline lineno="83"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />eccDp<sp />=<sp />Cy_Crypto_Core_ECC_GetCurveParams(key-&gt;<ref kindref="member" refid="structcy__stc__crypto__ecc__key_1ad999a0c46de4f1a4bc0c48313bc5b308">curveID</ref>);</highlight></codeline>
<codeline lineno="84"><highlight class="normal" /></codeline>
<codeline lineno="85"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(eccDp<sp />!=<sp />NULL)</highlight></codeline>
<codeline lineno="86"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="87"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />uint32_t<sp />bitsize<sp /><sp />=<sp />eccDp-&gt;<ref kindref="member" refid="structcy__stc__crypto__ecc__dp__type_1a95be0f2a7f0744d067f269c57415982c">size</ref>;</highlight></codeline>
<codeline lineno="88"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />uint32_t<sp />bytesize<sp />=<sp />CY_CRYPTO_BYTE_SIZE_OF_BITS(eccDp-&gt;<ref kindref="member" refid="structcy__stc__crypto__ecc__dp__type_1a95be0f2a7f0744d067f269c57415982c">size</ref>);</highlight></codeline>
<codeline lineno="89"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />uint32_t<sp />datasize<sp />=<sp />hashlen;</highlight></codeline>
<codeline lineno="90"><highlight class="normal" /></codeline>
<codeline lineno="91"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />make<sp />ephemeral<sp />key<sp />pair<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="92"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />ephKey.<ref kindref="member" refid="structcy__stc__crypto__ecc__key_1afb96fbe3e9ba91a3744cfcb5d653e7f5">pubkey</ref>.<ref kindref="member" refid="structcy__stc__crypto__ecc__point_1add55e76c8f42aec7b4274af7feeb1017">x</ref><sp />=<sp />myKGX;</highlight></codeline>
<codeline lineno="93"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />ephKey.<ref kindref="member" refid="structcy__stc__crypto__ecc__key_1afb96fbe3e9ba91a3744cfcb5d653e7f5">pubkey</ref>.<ref kindref="member" refid="structcy__stc__crypto__ecc__point_1aaf8d6d30379956a97aae67b103cc09b0">y</ref><sp />=<sp />myKGY;</highlight></codeline>
<codeline lineno="94"><highlight class="normal" /></codeline>
<codeline lineno="95"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />tmpResult<sp />=<sp /><ref kindref="member" refid="group__group__crypto__lld__asymmetric__functions_1ga7f2794ea5588d819aa19a1c1cfeec209">Cy_Crypto_Core_ECC_MakePublicKey</ref>(base,<sp />key-&gt;<ref kindref="member" refid="structcy__stc__crypto__ecc__key_1ad999a0c46de4f1a4bc0c48313bc5b308">curveID</ref>,<sp />messageKey,<sp />&amp;ephKey);</highlight></codeline>
<codeline lineno="96"><highlight class="normal" /></codeline>
<codeline lineno="97"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(<ref kindref="member" refid="group__group__crypto__enums_1gga3a65158da3dc5cb6aa016ae599542aada15d5a5e1314e16c159b7d3fd6f3501b8">CY_CRYPTO_SUCCESS</ref><sp />==<sp />tmpResult)</highlight></codeline>
<codeline lineno="98"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="99"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />tmpResult<sp />=<sp /><ref kindref="member" refid="group__group__crypto__enums_1gga3a65158da3dc5cb6aa016ae599542aada254861d7a75c5e292718d39dbbe84319">CY_CRYPTO_BAD_PARAMS</ref>;</highlight></codeline>
<codeline lineno="100"><highlight class="normal" /></codeline>
<codeline lineno="101"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />uint32_t<sp />dividend<sp />=<sp /><sp />0U;<sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />for<sp />whatever<sp />reason<sp />Crypto_EC_DivMod<sp />only<sp />works<sp />if<sp />dividend<sp />is<sp />in<sp />register<sp />0<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="102"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />uint32_t<sp />p_temp<sp /><sp /><sp />=<sp /><sp />8U;</highlight></codeline>
<codeline lineno="103"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />uint32_t<sp />p_r<sp /><sp /><sp /><sp /><sp /><sp />=<sp /><sp />9U;</highlight></codeline>
<codeline lineno="104"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />uint32_t<sp />p_s<sp /><sp /><sp /><sp /><sp /><sp />=<sp />10U;</highlight></codeline>
<codeline lineno="105"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />uint32_t<sp />p_d<sp /><sp /><sp /><sp /><sp /><sp />=<sp />11U;</highlight></codeline>
<codeline lineno="106"><highlight class="normal" /></codeline>
<codeline lineno="107"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />load<sp />values<sp />needed<sp />for<sp />reduction<sp />modulo<sp />order<sp />of<sp />the<sp />base<sp />point<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="108"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />CY_CRYPTO_VU_ALLOC_MEM<sp />(base,<sp />VR_P,<sp />bitsize);</highlight></codeline>
<codeline lineno="109"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__crypto__lld__vu__functions_1gad21cfd7efa413ac522736348d3e28813">Cy_Crypto_Core_Vu_SetMemValue</ref><sp />(base,<sp />VR_P,<sp />(uint8_t<sp />*)eccDp-&gt;<ref kindref="member" refid="structcy__stc__crypto__ecc__dp__type_1a3443f7da3a3fc50869c2a04ea497654c">order</ref>,<sp />bitsize);</highlight></codeline>
<codeline lineno="110"><highlight class="normal" /></codeline>
<codeline lineno="111"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />CY_CRYPTO_VU_ALLOC_MEM<sp />(base,<sp />VR_BARRETT,<sp />bitsize<sp />+<sp />1U);</highlight></codeline>
<codeline lineno="112"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__crypto__lld__vu__functions_1gad21cfd7efa413ac522736348d3e28813">Cy_Crypto_Core_Vu_SetMemValue</ref><sp />(base,<sp />VR_BARRETT,<sp />(uint8_t<sp />*)eccDp-&gt;<ref kindref="member" refid="structcy__stc__crypto__ecc__dp__type_1a9cd2894c6d48d780736fded492222b01">barrett_o</ref>,<sp />bitsize);</highlight></codeline>
<codeline lineno="113"><highlight class="normal" /></codeline>
<codeline lineno="114"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />CY_CRYPTO_VU_ALLOC_MEM<sp />(base,<sp />p_r,<sp />bitsize);</highlight></codeline>
<codeline lineno="115"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />CY_CRYPTO_VU_ALLOC_MEM<sp />(base,<sp />p_s,<sp />bitsize);</highlight></codeline>
<codeline lineno="116"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__crypto__lld__vu__functions_1gad21cfd7efa413ac522736348d3e28813">Cy_Crypto_Core_Vu_SetMemValue</ref><sp />(base,<sp />p_r,<sp />(uint8_t<sp />*)ephKey.<ref kindref="member" refid="structcy__stc__crypto__ecc__key_1afb96fbe3e9ba91a3744cfcb5d653e7f5">pubkey</ref>.<ref kindref="member" refid="structcy__stc__crypto__ecc__point_1add55e76c8f42aec7b4274af7feeb1017">x</ref>,<sp />bitsize);</highlight></codeline>
<codeline lineno="117"><highlight class="normal" /></codeline>
<codeline lineno="118"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />mallocMask<sp />=<sp />CY_CRYPTO_VU_REG_BIT(VR_P)<sp />|<sp />CY_CRYPTO_VU_REG_BIT(VR_BARRETT)<sp />|</highlight></codeline>
<codeline lineno="119"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />CY_CRYPTO_VU_REG_BIT(p_r)<sp /><sp />|<sp />CY_CRYPTO_VU_REG_BIT(p_s);</highlight></codeline>
<codeline lineno="120"><highlight class="normal" /></codeline>
<codeline lineno="121"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(!<ref kindref="member" refid="group__group__crypto__lld__vu__functions_1gaa7e7823e7b0d5a6e279bf90e405aec9e">Cy_Crypto_Core_Vu_IsRegZero</ref>(base,<sp />p_r))</highlight></codeline>
<codeline lineno="122"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="123"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />tmpResult<sp />=<sp /><ref kindref="member" refid="group__group__crypto__enums_1gga3a65158da3dc5cb6aa016ae599542aada15d5a5e1314e16c159b7d3fd6f3501b8">CY_CRYPTO_SUCCESS</ref>;</highlight></codeline>
<codeline lineno="124"><highlight class="normal" /></codeline>
<codeline lineno="125"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />CY_CRYPTO_VU_ALLOC_MEM<sp />(base,<sp />p_temp,<sp />bitsize);</highlight></codeline>
<codeline lineno="126"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />CY_CRYPTO_VU_ALLOC_MEM<sp />(base,<sp />p_d,<sp />datasize<sp />*<sp />8u);</highlight></codeline>
<codeline lineno="127"><highlight class="normal" /></codeline>
<codeline lineno="128"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />check<sp />that<sp />x1<sp />is<sp />smaller<sp />than<sp />the<sp />order<sp />of<sp />the<sp />base<sp />point<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="129"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(!<ref kindref="member" refid="group__group__crypto__lld__vu__functions_1ga114cfba2b92c9b5344bb998dba0c5c8d">Cy_Crypto_Core_Vu_IsRegLess</ref>(base,<sp />p_r,<sp />VR_P))</highlight></codeline>
<codeline lineno="130"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="131"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />x1<sp />&gt;=<sp />order,<sp />needs<sp />reduction<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="132"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />CY_CRYPTO_VU_MOV(base,<sp />p_temp,<sp />p_r);</highlight></codeline>
<codeline lineno="133"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__crypto__lld__hw__functions_1ga17c57fe13a519b0273fe9dee78dae44b">Cy_Crypto_Core_Vu_WaitForComplete</ref>(base);</highlight></codeline>
<codeline lineno="134"><highlight class="normal" /></codeline>
<codeline lineno="135"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />z<sp />=<sp />x<sp />%<sp />mod<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="136"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />Cy_Crypto_Core_EC_Bar_MulRed(base,<sp />p_r,<sp />p_temp,<sp />bitsize);</highlight></codeline>
<codeline lineno="137"><highlight class="normal" /></codeline>
<codeline lineno="138"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />r<sp />=<sp />x1<sp />mod<sp />n<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="139"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__crypto__lld__vu__functions_1ga656498f4aad29b0c489b098093fde8d3">Cy_Crypto_Core_Vu_GetMemValue</ref><sp />(base,<sp />sig,<sp />p_r,<sp />bitsize);</highlight></codeline>
<codeline lineno="140"><highlight class="normal" /></codeline>
<codeline lineno="141"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(<ref kindref="member" refid="group__group__crypto__lld__vu__functions_1gaa7e7823e7b0d5a6e279bf90e405aec9e">Cy_Crypto_Core_Vu_IsRegZero</ref>(base,<sp />p_r))</highlight></codeline>
<codeline lineno="142"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="143"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />R<sp />is<sp />zero!!!<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="144"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />tmpResult<sp />=<sp /><ref kindref="member" refid="group__group__crypto__enums_1gga3a65158da3dc5cb6aa016ae599542aada44acf6978f89cc1df07f6d0d52b6ed77">CY_CRYPTO_HW_ERROR</ref>;</highlight></codeline>
<codeline lineno="145"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="146"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="147"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">else</highlight><highlight class="normal" /></codeline>
<codeline lineno="148"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="149"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />carry<sp />is<sp />clear,<sp />i.<sp />e.<sp />x1<sp />&lt;<sp />order,<sp />r<sp />=<sp />x1<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="150"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__crypto__lld__vu__functions_1ga656498f4aad29b0c489b098093fde8d3">Cy_Crypto_Core_Vu_GetMemValue</ref>(base,<sp />sig,<sp />p_r,<sp />bitsize);</highlight></codeline>
<codeline lineno="151"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="152"><highlight class="normal" /></codeline>
<codeline lineno="153"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(<ref kindref="member" refid="group__group__crypto__enums_1gga3a65158da3dc5cb6aa016ae599542aada15d5a5e1314e16c159b7d3fd6f3501b8">CY_CRYPTO_SUCCESS</ref><sp />==<sp />tmpResult)</highlight></codeline>
<codeline lineno="154"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="155"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />find<sp />s<sp />=<sp />(e<sp />+<sp />d*r)/k<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="156"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />load<sp />signing<sp />private<sp />key<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="157"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__crypto__lld__vu__functions_1gad21cfd7efa413ac522736348d3e28813">Cy_Crypto_Core_Vu_SetMemValue</ref><sp />(base,<sp />p_temp,<sp />(uint8_t<sp />*)key-&gt;<ref kindref="member" refid="structcy__stc__crypto__ecc__key_1ad01fbcfdfa38d51908420fdbd3c33366">k</ref>,<sp />bitsize);</highlight></codeline>
<codeline lineno="158"><highlight class="normal" /></codeline>
<codeline lineno="159"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />use<sp />Barrett<sp />reduction<sp />algorithm<sp />for<sp />operations<sp />modulo<sp />n<sp />(order<sp />of<sp />the<sp />base<sp />point)<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="160"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />Cy_Crypto_Core_EC_NistP_SetRedAlg(CY_CRYPTO_NIST_P_BARRETT_RED_ALG);</highlight></codeline>
<codeline lineno="161"><highlight class="normal" /></codeline>
<codeline lineno="162"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />d*r<sp />mod<sp />n<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="163"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />Cy_Crypto_Core_EC_MulMod(base,<sp />p_s,<sp />p_temp,<sp />p_r,<sp />bitsize);<sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />z<sp />=<sp />a<sp />*<sp />b<sp />%<sp />mod<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="164"><highlight class="normal" /></codeline>
<codeline lineno="165"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />load<sp />message<sp />hash,<sp />truncate<sp />it<sp />if<sp />needed.<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="166"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__crypto__lld__vu__functions_1gad21cfd7efa413ac522736348d3e28813">Cy_Crypto_Core_Vu_SetMemValue</ref><sp />(base,<sp />p_d,<sp />(uint8_t<sp />*)hash,<sp />datasize<sp />*<sp />8u);</highlight></codeline>
<codeline lineno="167"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__crypto__lld__vu__functions_1ga08aa3a35101cb64a96fa0b744aae35d0">Cy_Crypto_Core_VU_RegInvertEndianness</ref>(base,<sp />p_d);</highlight></codeline>
<codeline lineno="168"><highlight class="normal" /></codeline>
<codeline lineno="169"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />((datasize<sp />*<sp />8u)<sp />&gt;<sp />bitsize)</highlight></codeline>
<codeline lineno="170"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="171"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />CY_CRYPTO_VU_SET_REG(base,<sp />dividend,<sp />(datasize<sp />*<sp />8u)<sp />-<sp />bitsize,<sp />1u);</highlight></codeline>
<codeline lineno="172"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />CY_CRYPTO_VU_LSR(base,<sp />p_d,<sp />p_d,<sp />dividend);</highlight></codeline>
<codeline lineno="173"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="174"><highlight class="normal" /></codeline>
<codeline lineno="175"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />check<sp />that<sp />the<sp />prepared<sp />hash<sp />value<sp />is<sp />smaller<sp />than<sp />the<sp />order<sp />of<sp />base<sp />point<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="176"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(!<ref kindref="member" refid="group__group__crypto__lld__vu__functions_1ga114cfba2b92c9b5344bb998dba0c5c8d">Cy_Crypto_Core_Vu_IsRegLess</ref>(base,<sp />p_d,<sp />VR_P))</highlight></codeline>
<codeline lineno="177"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="178"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />CY_CRYPTO_VU_MOV(base,<sp />p_temp,<sp />p_d);</highlight></codeline>
<codeline lineno="179"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__crypto__lld__hw__functions_1ga17c57fe13a519b0273fe9dee78dae44b">Cy_Crypto_Core_Vu_WaitForComplete</ref>(base);</highlight></codeline>
<codeline lineno="180"><highlight class="normal" /></codeline>
<codeline lineno="181"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />z<sp />=<sp />x<sp />%<sp />mod<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="182"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />Cy_Crypto_Core_EC_Bar_MulRed(base,<sp />p_d,<sp />p_temp,<sp />bitsize);</highlight></codeline>
<codeline lineno="183"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="184"><highlight class="normal" /></codeline>
<codeline lineno="185"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Use<sp />p_r<sp />as<sp />temporary<sp />register<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="186"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__crypto__lld__vu__functions_1gad21cfd7efa413ac522736348d3e28813">Cy_Crypto_Core_Vu_SetMemValue</ref><sp />(base,<sp />p_r,<sp />messageKey,<sp />bitsize);</highlight></codeline>
<codeline lineno="187"><highlight class="normal" /></codeline>
<codeline lineno="188"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />e<sp />+<sp />d*r<sp />mod<sp />n<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="189"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />Cy_Crypto_Core_EC_AddMod<sp />(base,<sp />p_s,<sp />p_d,<sp />p_s);<sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />z<sp />=<sp />a<sp />+<sp />b<sp />%<sp />mod<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="190"><highlight class="normal" /></codeline>
<codeline lineno="191"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />(e<sp />+<sp />d*r)/k<sp />mod<sp />n<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="192"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />CY_CRYPTO_VU_ALLOC_MEM<sp />(base,<sp />dividend,<sp />bitsize);</highlight></codeline>
<codeline lineno="193"><highlight class="normal" /></codeline>
<codeline lineno="194"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />CY_CRYPTO_VU_MOV(base,<sp />dividend,<sp />p_s);</highlight></codeline>
<codeline lineno="195"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__crypto__lld__hw__functions_1ga17c57fe13a519b0273fe9dee78dae44b">Cy_Crypto_Core_Vu_WaitForComplete</ref>(base);</highlight></codeline>
<codeline lineno="196"><highlight class="normal" /></codeline>
<codeline lineno="197"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />z<sp />=<sp />a<sp />/<sp />b<sp />%<sp />mod<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="198"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />Cy_Crypto_Core_EC_DivMod(base,<sp />p_s,<sp />dividend,<sp />p_r,<sp />bitsize);</highlight></codeline>
<codeline lineno="199"><highlight class="normal" /></codeline>
<codeline lineno="200"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />CY_CRYPTO_VU_FREE_MEM(base,<sp />CY_CRYPTO_VU_REG_BIT(dividend));</highlight></codeline>
<codeline lineno="201"><highlight class="normal" /></codeline>
<codeline lineno="202"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(!<ref kindref="member" refid="group__group__crypto__lld__vu__functions_1gaa7e7823e7b0d5a6e279bf90e405aec9e">Cy_Crypto_Core_Vu_IsRegZero</ref>(base,<sp />p_s))</highlight></codeline>
<codeline lineno="203"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="204"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />S<sp />is<sp />not<sp />zero!!!<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="205"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__crypto__lld__vu__functions_1ga656498f4aad29b0c489b098093fde8d3">Cy_Crypto_Core_Vu_GetMemValue</ref><sp />(base,<sp />&amp;sig[bytesize],<sp />p_s,<sp />bitsize);</highlight></codeline>
<codeline lineno="206"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="207"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">else</highlight><highlight class="normal" /></codeline>
<codeline lineno="208"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="209"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />tmpResult<sp />=<sp /><ref kindref="member" refid="group__group__crypto__enums_1gga3a65158da3dc5cb6aa016ae599542aada44acf6978f89cc1df07f6d0d52b6ed77">CY_CRYPTO_HW_ERROR</ref>;</highlight></codeline>
<codeline lineno="210"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="211"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="212"><highlight class="normal" /></codeline>
<codeline lineno="213"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />CY_CRYPTO_VU_FREE_MEM(base,<sp />CY_CRYPTO_VU_REG_BIT(p_d)<sp />|<sp />CY_CRYPTO_VU_REG_BIT(p_temp));</highlight></codeline>
<codeline lineno="214"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="215"><highlight class="normal" /></codeline>
<codeline lineno="216"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />CY_CRYPTO_VU_FREE_MEM(base,<sp />mallocMask);</highlight></codeline>
<codeline lineno="217"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="218"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="219"><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="220"><highlight class="normal" /></codeline>
<codeline lineno="221"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">return</highlight><highlight class="normal"><sp />(tmpResult);</highlight></codeline>
<codeline lineno="222"><highlight class="normal">}</highlight></codeline>
<codeline lineno="223"><highlight class="normal" /></codeline>
<codeline lineno="224"><highlight class="normal" /></codeline>
<codeline lineno="225"><highlight class="normal" /><highlight class="comment">/*******************************************************************************</highlight></codeline>
<codeline lineno="226"><highlight class="comment">*<sp />Function<sp />Name:<sp />Cy_Crypto_Core_ECC_VerifyHash</highlight></codeline>
<codeline lineno="227"><highlight class="comment">****************************************************************************/</highlight></codeline>
<codeline lineno="252"><highlight class="normal"><ref kindref="member" refid="group__group__crypto__enums_1ga3a65158da3dc5cb6aa016ae599542aad">cy_en_crypto_status_t</ref><sp /><ref kindref="member" refid="group__group__crypto__lld__asymmetric__functions_1ga1d1d01ef464f6609df2a5c1ba4186d86">Cy_Crypto_Core_ECC_VerifyHash</ref>(CRYPTO_Type<sp />*base,</highlight></codeline>
<codeline lineno="253"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keyword">const</highlight><highlight class="normal"><sp />uint8_t<sp />*sig,<sp /></highlight><highlight class="keyword">const</highlight><highlight class="normal"><sp />uint8_t<sp />*hash,<sp />uint32_t<sp />hashlen,</highlight></codeline>
<codeline lineno="254"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />uint8_t<sp />*stat,<sp /></highlight><highlight class="keyword">const</highlight><highlight class="normal"><sp /><ref kindref="compound" refid="structcy__stc__crypto__ecc__key">cy_stc_crypto_ecc_key</ref><sp />*key)</highlight></codeline>
<codeline lineno="255"><highlight class="normal">{</highlight></codeline>
<codeline lineno="256"><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__crypto__enums_1ga3a65158da3dc5cb6aa016ae599542aad">cy_en_crypto_status_t</ref><sp />tmpResult<sp />=<sp /><ref kindref="member" refid="group__group__crypto__enums_1gga3a65158da3dc5cb6aa016ae599542aada254861d7a75c5e292718d39dbbe84319">CY_CRYPTO_BAD_PARAMS</ref>;</highlight></codeline>
<codeline lineno="257"><highlight class="normal" /></codeline>
<codeline lineno="258"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keyword">const</highlight><highlight class="normal"><sp /><ref kindref="compound" refid="structcy__stc__crypto__ecc__dp__type">cy_stc_crypto_ecc_dp_type</ref><sp />*eccDp;</highlight></codeline>
<codeline lineno="259"><highlight class="normal" /></codeline>
<codeline lineno="260"><highlight class="normal"><sp /><sp /><sp /><sp />uint32_t<sp />mallocMask<sp />=<sp />0U;</highlight></codeline>
<codeline lineno="261"><highlight class="normal" /></codeline>
<codeline lineno="262"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />NULL<sp />parameters<sp />checking<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="263"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />((sig<sp />!=<sp />NULL)<sp />&amp;&amp;<sp />(hash<sp />!=<sp />NULL)<sp />&amp;&amp;<sp />(stat<sp />!=<sp />NULL)<sp />&amp;&amp;<sp />(key<sp />!=<sp />NULL))</highlight></codeline>
<codeline lineno="264"><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="265"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />tmpResult<sp />=<sp /><ref kindref="member" refid="group__group__crypto__enums_1gga3a65158da3dc5cb6aa016ae599542aada3bba593d15daa1e8e07acd1c5d110af2">CY_CRYPTO_NOT_SUPPORTED</ref>;</highlight></codeline>
<codeline lineno="266"><highlight class="normal" /></codeline>
<codeline lineno="267"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />eccDp<sp />=<sp />Cy_Crypto_Core_ECC_GetCurveParams(key-&gt;<ref kindref="member" refid="structcy__stc__crypto__ecc__key_1ad999a0c46de4f1a4bc0c48313bc5b308">curveID</ref>);</highlight></codeline>
<codeline lineno="268"><highlight class="normal" /></codeline>
<codeline lineno="269"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(eccDp<sp />!=<sp />NULL)</highlight></codeline>
<codeline lineno="270"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="271"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />tmpResult<sp />=<sp /><ref kindref="member" refid="group__group__crypto__enums_1gga3a65158da3dc5cb6aa016ae599542aada15d5a5e1314e16c159b7d3fd6f3501b8">CY_CRYPTO_SUCCESS</ref>;</highlight></codeline>
<codeline lineno="272"><highlight class="normal" /></codeline>
<codeline lineno="273"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />uint32_t<sp />bitsize<sp /><sp />=<sp />eccDp-&gt;<ref kindref="member" refid="structcy__stc__crypto__ecc__dp__type_1a95be0f2a7f0744d067f269c57415982c">size</ref>;</highlight></codeline>
<codeline lineno="274"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />uint32_t<sp />bytesize<sp />=<sp />CY_CRYPTO_BYTE_SIZE_OF_BITS(eccDp-&gt;<ref kindref="member" refid="structcy__stc__crypto__ecc__dp__type_1a95be0f2a7f0744d067f269c57415982c">size</ref>);</highlight></codeline>
<codeline lineno="275"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />uint32_t<sp />datasize<sp />=<sp />hashlen;</highlight></codeline>
<codeline lineno="276"><highlight class="normal" /></codeline>
<codeline lineno="277"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />uint32_t<sp />dividend<sp />=<sp />0u;<sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />for<sp />whatever<sp />reason<sp />Crypto_EC_DivMod<sp />only<sp />works<sp />if<sp />dividend<sp />is<sp />in<sp />register<sp />0<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="278"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />uint32_t<sp />p_r<sp /><sp />=<sp />4U;</highlight></codeline>
<codeline lineno="279"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />uint32_t<sp />p_s<sp /><sp />=<sp />5U;</highlight></codeline>
<codeline lineno="280"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />uint32_t<sp />p_u1<sp />=<sp />6U;</highlight></codeline>
<codeline lineno="281"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />uint32_t<sp />p_u2<sp />=<sp />7U;</highlight></codeline>
<codeline lineno="282"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />uint32_t<sp />p_o<sp /><sp />=<sp />8U;</highlight></codeline>
<codeline lineno="283"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />uint32_t<sp />p_gx<sp />=<sp />9U;</highlight></codeline>
<codeline lineno="284"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />uint32_t<sp />p_gy<sp />=<sp />10U;</highlight></codeline>
<codeline lineno="285"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />uint32_t<sp />p_qx<sp />=<sp />11U;</highlight></codeline>
<codeline lineno="286"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />uint32_t<sp />p_qy<sp />=<sp />12U;</highlight></codeline>
<codeline lineno="287"><highlight class="normal" /></codeline>
<codeline lineno="288"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />use<sp />Barrett<sp />reduction<sp />algorithm<sp />for<sp />operations<sp />modulo<sp />n<sp />(order<sp />of<sp />the<sp />base<sp />point)<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="289"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />Cy_Crypto_Core_EC_NistP_SetRedAlg(CY_CRYPTO_NIST_P_BARRETT_RED_ALG);</highlight></codeline>
<codeline lineno="290"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />Cy_Crypto_Core_EC_NistP_SetMode(bitsize);</highlight></codeline>
<codeline lineno="291"><highlight class="normal" /></codeline>
<codeline lineno="292"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*******************************************************************************/</highlight><highlight class="normal" /></codeline>
<codeline lineno="293"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />load<sp />values<sp />needed<sp />for<sp />reduction<sp />modulo<sp />order<sp />of<sp />the<sp />base<sp />point<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="294"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />CY_CRYPTO_VU_ALLOC_MEM<sp />(base,<sp />VR_P,<sp />bitsize);</highlight></codeline>
<codeline lineno="295"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__crypto__lld__vu__functions_1gad21cfd7efa413ac522736348d3e28813">Cy_Crypto_Core_Vu_SetMemValue</ref><sp />(base,<sp />VR_P,<sp />(uint8_t<sp />*)eccDp-&gt;<ref kindref="member" refid="structcy__stc__crypto__ecc__dp__type_1a3443f7da3a3fc50869c2a04ea497654c">order</ref>,<sp />bitsize);</highlight></codeline>
<codeline lineno="296"><highlight class="normal" /></codeline>
<codeline lineno="297"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />CY_CRYPTO_VU_ALLOC_MEM<sp />(base,<sp />VR_BARRETT,<sp />bitsize<sp />+<sp />1U);</highlight></codeline>
<codeline lineno="298"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__crypto__lld__vu__functions_1gad21cfd7efa413ac522736348d3e28813">Cy_Crypto_Core_Vu_SetMemValue</ref><sp />(base,<sp />VR_BARRETT,<sp />(uint8_t<sp />*)eccDp-&gt;<ref kindref="member" refid="structcy__stc__crypto__ecc__dp__type_1a9cd2894c6d48d780736fded492222b01">barrett_o</ref>,<sp />bitsize<sp />+<sp />1U);</highlight></codeline>
<codeline lineno="299"><highlight class="normal" /></codeline>
<codeline lineno="300"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*******************************************************************************/</highlight><highlight class="normal" /></codeline>
<codeline lineno="301"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />check<sp />that<sp />R<sp />and<sp />S<sp />are<sp />within<sp />the<sp />valid<sp />range,<sp />i.e.<sp />0<sp />&lt;<sp />R<sp />&lt;<sp />n<sp />and<sp />0<sp />&lt;<sp />S<sp />&lt;<sp />n<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="302"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />CY_CRYPTO_VU_ALLOC_MEM<sp />(base,<sp />p_r,<sp />bitsize);</highlight></codeline>
<codeline lineno="303"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />CY_CRYPTO_VU_ALLOC_MEM<sp />(base,<sp />p_s,<sp />bitsize);</highlight></codeline>
<codeline lineno="304"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__crypto__lld__vu__functions_1gad21cfd7efa413ac522736348d3e28813">Cy_Crypto_Core_Vu_SetMemValue</ref><sp />(base,<sp />p_r,<sp />(uint8_t<sp />*)sig,<sp />bitsize);</highlight></codeline>
<codeline lineno="305"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__crypto__lld__vu__functions_1gad21cfd7efa413ac522736348d3e28813">Cy_Crypto_Core_Vu_SetMemValue</ref><sp />(base,<sp />p_s,<sp />(uint8_t<sp />*)&amp;sig[bytesize],<sp />bitsize);</highlight></codeline>
<codeline lineno="306"><highlight class="normal" /></codeline>
<codeline lineno="307"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />mallocMask<sp />=<sp />CY_CRYPTO_VU_REG_BIT(VR_P)<sp />|<sp />CY_CRYPTO_VU_REG_BIT(VR_BARRETT)<sp />|</highlight></codeline>
<codeline lineno="308"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />CY_CRYPTO_VU_REG_BIT(p_r)<sp /><sp />|<sp />CY_CRYPTO_VU_REG_BIT(p_s);</highlight></codeline>
<codeline lineno="309"><highlight class="normal" /></codeline>
<codeline lineno="310"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Check<sp />R<sp />and<sp />S<sp />range<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="311"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(<ref kindref="member" refid="group__group__crypto__lld__vu__functions_1gaa7e7823e7b0d5a6e279bf90e405aec9e">Cy_Crypto_Core_Vu_IsRegZero</ref>(base,<sp />p_r))</highlight></codeline>
<codeline lineno="312"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="313"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />R<sp />is<sp />zero!!!<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="314"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />tmpResult<sp />=<sp /><ref kindref="member" refid="group__group__crypto__enums_1gga3a65158da3dc5cb6aa016ae599542aada254861d7a75c5e292718d39dbbe84319">CY_CRYPTO_BAD_PARAMS</ref>;</highlight></codeline>
<codeline lineno="315"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="316"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(!<ref kindref="member" refid="group__group__crypto__lld__vu__functions_1ga114cfba2b92c9b5344bb998dba0c5c8d">Cy_Crypto_Core_Vu_IsRegLess</ref>(base,<sp />p_r,<sp />VR_P))</highlight></codeline>
<codeline lineno="317"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="318"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />R<sp />is<sp />not<sp />less<sp />than<sp />n!!!<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="319"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />tmpResult<sp />=<sp /><ref kindref="member" refid="group__group__crypto__enums_1gga3a65158da3dc5cb6aa016ae599542aada254861d7a75c5e292718d39dbbe84319">CY_CRYPTO_BAD_PARAMS</ref>;</highlight></codeline>
<codeline lineno="320"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="321"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(<ref kindref="member" refid="group__group__crypto__lld__vu__functions_1gaa7e7823e7b0d5a6e279bf90e405aec9e">Cy_Crypto_Core_Vu_IsRegZero</ref>(base,<sp />p_s))</highlight></codeline>
<codeline lineno="322"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="323"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />S<sp />is<sp />zero!!!<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="324"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />tmpResult<sp />=<sp /><ref kindref="member" refid="group__group__crypto__enums_1gga3a65158da3dc5cb6aa016ae599542aada254861d7a75c5e292718d39dbbe84319">CY_CRYPTO_BAD_PARAMS</ref>;</highlight></codeline>
<codeline lineno="325"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="326"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(!<ref kindref="member" refid="group__group__crypto__lld__vu__functions_1ga114cfba2b92c9b5344bb998dba0c5c8d">Cy_Crypto_Core_Vu_IsRegLess</ref>(base,<sp />p_s,<sp />VR_P))</highlight></codeline>
<codeline lineno="327"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="328"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />S<sp />is<sp />not<sp />less<sp />than<sp />n!!!<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="329"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />tmpResult<sp />=<sp /><ref kindref="member" refid="group__group__crypto__enums_1gga3a65158da3dc5cb6aa016ae599542aada254861d7a75c5e292718d39dbbe84319">CY_CRYPTO_BAD_PARAMS</ref>;</highlight></codeline>
<codeline lineno="330"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="331"><highlight class="normal" /></codeline>
<codeline lineno="332"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(<ref kindref="member" refid="group__group__crypto__enums_1gga3a65158da3dc5cb6aa016ae599542aada15d5a5e1314e16c159b7d3fd6f3501b8">CY_CRYPTO_SUCCESS</ref><sp />==<sp />tmpResult)</highlight></codeline>
<codeline lineno="333"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="334"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />CY_CRYPTO_VU_ALLOC_MEM<sp />(base,<sp />p_u1,<sp />bitsize);</highlight></codeline>
<codeline lineno="335"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />CY_CRYPTO_VU_ALLOC_MEM<sp />(base,<sp />p_u2,<sp />bitsize);</highlight></codeline>
<codeline lineno="336"><highlight class="normal" /></codeline>
<codeline lineno="337"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />CY_CRYPTO_VU_ALLOC_MEM<sp />(base,<sp />p_gx,<sp />bitsize);</highlight></codeline>
<codeline lineno="338"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />CY_CRYPTO_VU_ALLOC_MEM<sp />(base,<sp />p_gy,<sp />bitsize);</highlight></codeline>
<codeline lineno="339"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />CY_CRYPTO_VU_ALLOC_MEM<sp />(base,<sp />p_qx,<sp />bitsize);</highlight></codeline>
<codeline lineno="340"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />CY_CRYPTO_VU_ALLOC_MEM<sp />(base,<sp />p_qy,<sp />bitsize);</highlight></codeline>
<codeline lineno="341"><highlight class="normal" /></codeline>
<codeline lineno="342"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />mallocMask<sp />|=<sp />CY_CRYPTO_VU_REG_BIT(dividend)<sp />|</highlight></codeline>
<codeline lineno="343"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />CY_CRYPTO_VU_REG_BIT(p_u1)<sp />|<sp />CY_CRYPTO_VU_REG_BIT(p_u2)<sp />|</highlight></codeline>
<codeline lineno="344"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />CY_CRYPTO_VU_REG_BIT(p_gx)<sp />|<sp />CY_CRYPTO_VU_REG_BIT(p_gy)<sp />|</highlight></codeline>
<codeline lineno="345"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />CY_CRYPTO_VU_REG_BIT(p_qx)<sp />|<sp />CY_CRYPTO_VU_REG_BIT(p_qy);</highlight></codeline>
<codeline lineno="346"><highlight class="normal" /></codeline>
<codeline lineno="347"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />load<sp />message<sp />hash,<sp />truncate<sp />it<sp />if<sp />needed<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="348"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />CY_CRYPTO_VU_SET_TO_ZERO(base,<sp />p_u1);</highlight></codeline>
<codeline lineno="349"><highlight class="normal" /></codeline>
<codeline lineno="350"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />load<sp />message<sp />hash,<sp />truncate<sp />it<sp />if<sp />needed.<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="351"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />CY_CRYPTO_VU_ALLOC_MEM<sp />(base,<sp />p_o,<sp /><sp />datasize<sp />*<sp />8u);</highlight></codeline>
<codeline lineno="352"><highlight class="normal" /></codeline>
<codeline lineno="353"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />CY_CRYPTO_VU_SET_TO_ZERO(base,<sp />p_o);</highlight></codeline>
<codeline lineno="354"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__crypto__lld__vu__functions_1gad21cfd7efa413ac522736348d3e28813">Cy_Crypto_Core_Vu_SetMemValue</ref><sp />(base,<sp />p_o,<sp />(uint8_t<sp />*)hash,<sp />datasize<sp />*<sp />8u);</highlight></codeline>
<codeline lineno="355"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__crypto__lld__vu__functions_1ga08aa3a35101cb64a96fa0b744aae35d0">Cy_Crypto_Core_VU_RegInvertEndianness</ref>(base,<sp />p_o);</highlight></codeline>
<codeline lineno="356"><highlight class="normal" /></codeline>
<codeline lineno="357"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />((datasize<sp />*<sp />8u)<sp />&gt;<sp />bitsize)</highlight></codeline>
<codeline lineno="358"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="359"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />CY_CRYPTO_VU_SET_REG(base,<sp />dividend,<sp />(datasize<sp />*<sp />8u)<sp />-<sp />bitsize,<sp />1u);</highlight></codeline>
<codeline lineno="360"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />CY_CRYPTO_VU_LSR(base,<sp />p_o,<sp />p_o,<sp />dividend);</highlight></codeline>
<codeline lineno="361"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="362"><highlight class="normal" /></codeline>
<codeline lineno="363"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Use<sp />p_o<sp />as<sp />temporary<sp />register<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="364"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />CY_CRYPTO_VU_MOV(base,<sp />p_u1,<sp />p_o);</highlight></codeline>
<codeline lineno="365"><highlight class="normal" /></codeline>
<codeline lineno="366"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />CY_CRYPTO_VU_FREE_MEM(base,<sp />CY_CRYPTO_VU_REG_BIT(p_o));</highlight></codeline>
<codeline lineno="367"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />CY_CRYPTO_VU_ALLOC_MEM<sp />(base,<sp />p_o,<sp />bitsize);</highlight></codeline>
<codeline lineno="368"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />CY_CRYPTO_VU_ALLOC_MEM<sp />(base,<sp />dividend,<sp />bitsize);</highlight></codeline>
<codeline lineno="369"><highlight class="normal" /></codeline>
<codeline lineno="370"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />check<sp />that<sp />the<sp />prepared<sp />hash<sp />value<sp />is<sp />smaller<sp />than<sp />the<sp />order<sp />of<sp />base<sp />point<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="371"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(!<ref kindref="member" refid="group__group__crypto__lld__vu__functions_1ga114cfba2b92c9b5344bb998dba0c5c8d">Cy_Crypto_Core_Vu_IsRegLess</ref>(base,<sp />p_u1,<sp />VR_P))</highlight></codeline>
<codeline lineno="372"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="373"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Use<sp />p_o<sp />as<sp />temporary<sp />register<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="374"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />CY_CRYPTO_VU_MOV(base,<sp />p_o,<sp />p_u1);</highlight></codeline>
<codeline lineno="375"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__crypto__lld__hw__functions_1ga17c57fe13a519b0273fe9dee78dae44b">Cy_Crypto_Core_Vu_WaitForComplete</ref>(base);</highlight></codeline>
<codeline lineno="376"><highlight class="normal" /></codeline>
<codeline lineno="377"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />z<sp />=<sp />x<sp />%<sp />mod<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="378"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />Cy_Crypto_Core_EC_Bar_MulRed(base,<sp />p_u1,<sp />p_o,<sp />bitsize);</highlight></codeline>
<codeline lineno="379"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="380"><highlight class="normal" /></codeline>
<codeline lineno="381"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />w<sp />=<sp />s^-1<sp />mod<sp />n<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="382"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />CY_CRYPTO_VU_SET_TO_ONE(base,<sp />dividend);</highlight></codeline>
<codeline lineno="383"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />Cy_Crypto_Core_EC_DivMod(base,<sp />p_s,<sp />dividend,<sp />p_s,<sp />bitsize);</highlight></codeline>
<codeline lineno="384"><highlight class="normal" /></codeline>
<codeline lineno="385"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />u1<sp />=<sp />e*w<sp />mod<sp />n<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="386"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />Cy_Crypto_Core_EC_MulMod(base,<sp />p_u1,<sp />p_u1,<sp />p_s,<sp />bitsize);</highlight></codeline>
<codeline lineno="387"><highlight class="normal" /></codeline>
<codeline lineno="388"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />u2<sp />=<sp />r*w<sp />mod<sp />n<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="389"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />Cy_Crypto_Core_EC_MulMod(base,<sp />p_u2,<sp />p_r,<sp />p_s,<sp />bitsize);</highlight></codeline>
<codeline lineno="390"><highlight class="normal" /></codeline>
<codeline lineno="391"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Initialize<sp />point<sp />multiplication<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="392"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />Cy_Crypto_Core_EC_NistP_SetRedAlg(eccDp-&gt;<ref kindref="member" refid="structcy__stc__crypto__ecc__dp__type_1a21a15ceafa7b448925b7239872aad5a9">algo</ref>);</highlight></codeline>
<codeline lineno="393"><highlight class="normal" /></codeline>
<codeline lineno="394"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />load<sp />prime,<sp />order<sp />and<sp />Barrett<sp />coefficient<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="395"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__crypto__lld__vu__functions_1gad21cfd7efa413ac522736348d3e28813">Cy_Crypto_Core_Vu_SetMemValue</ref><sp />(base,<sp />VR_P,<sp />(uint8_t<sp />*)eccDp-&gt;<ref kindref="member" refid="structcy__stc__crypto__ecc__dp__type_1a4ec7bbd0ab6b5dbdf61a80986138730e">prime</ref>,<sp />bitsize);</highlight></codeline>
<codeline lineno="396"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__crypto__lld__vu__functions_1gad21cfd7efa413ac522736348d3e28813">Cy_Crypto_Core_Vu_SetMemValue</ref><sp />(base,<sp />VR_BARRETT,<sp />(uint8_t<sp />*)eccDp-&gt;<ref kindref="member" refid="structcy__stc__crypto__ecc__dp__type_1a32985516423929455def0b6a6ce8523e">barrett_p</ref>,<sp />bitsize<sp />+<sp />1U);</highlight></codeline>
<codeline lineno="397"><highlight class="normal" /></codeline>
<codeline lineno="398"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />load<sp />base<sp />Point<sp />G<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="399"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__crypto__lld__vu__functions_1gad21cfd7efa413ac522736348d3e28813">Cy_Crypto_Core_Vu_SetMemValue</ref><sp />(base,<sp />p_gx,<sp />(uint8_t<sp />*)eccDp-&gt;<ref kindref="member" refid="structcy__stc__crypto__ecc__dp__type_1afaa676872b1fbc0b6e6874cfe094bf45">Gx</ref>,<sp />bitsize);</highlight></codeline>
<codeline lineno="400"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__crypto__lld__vu__functions_1gad21cfd7efa413ac522736348d3e28813">Cy_Crypto_Core_Vu_SetMemValue</ref><sp />(base,<sp />p_gy,<sp />(uint8_t<sp />*)eccDp-&gt;<ref kindref="member" refid="structcy__stc__crypto__ecc__dp__type_1a5e622c68bec0d723529dfe1050c2be30">Gy</ref>,<sp />bitsize);</highlight></codeline>
<codeline lineno="401"><highlight class="normal" /></codeline>
<codeline lineno="402"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />load<sp />public<sp />key<sp />Qa<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="403"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__crypto__lld__vu__functions_1gad21cfd7efa413ac522736348d3e28813">Cy_Crypto_Core_Vu_SetMemValue</ref><sp />(base,<sp />p_qx,<sp />(uint8_t<sp />*)key-&gt;<ref kindref="member" refid="structcy__stc__crypto__ecc__key_1afb96fbe3e9ba91a3744cfcb5d653e7f5">pubkey</ref>.<ref kindref="member" refid="structcy__stc__crypto__ecc__point_1add55e76c8f42aec7b4274af7feeb1017">x</ref>,<sp />bitsize);</highlight></codeline>
<codeline lineno="404"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__crypto__lld__vu__functions_1gad21cfd7efa413ac522736348d3e28813">Cy_Crypto_Core_Vu_SetMemValue</ref><sp />(base,<sp />p_qy,<sp />(uint8_t<sp />*)key-&gt;<ref kindref="member" refid="structcy__stc__crypto__ecc__key_1afb96fbe3e9ba91a3744cfcb5d653e7f5">pubkey</ref>.<ref kindref="member" refid="structcy__stc__crypto__ecc__point_1aaf8d6d30379956a97aae67b103cc09b0">y</ref>,<sp />bitsize);</highlight></codeline>
<codeline lineno="405"><highlight class="normal" /></codeline>
<codeline lineno="406"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />u1<sp />*<sp />G<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="407"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />Cy_Crypto_Core_EC_NistP_PointMul(base,<sp />p_gx,<sp />p_gy,<sp />p_u1,<sp />p_o,<sp />bitsize);</highlight></codeline>
<codeline lineno="408"><highlight class="normal" /></codeline>
<codeline lineno="409"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />u2<sp />*<sp />Qa<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="410"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />Cy_Crypto_Core_EC_NistP_PointMul(base,<sp />p_qx,<sp />p_qy,<sp />p_u2,<sp />p_o,<sp />bitsize);</highlight></codeline>
<codeline lineno="411"><highlight class="normal" /></codeline>
<codeline lineno="412"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />P<sp />=<sp />u1<sp />*<sp />G<sp />+<sp />u2<sp />*<sp />Qa.<sp />Only<sp />Px<sp />is<sp />needed<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="413"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />Cy_Crypto_Core_EC_SubMod(base,<sp />dividend,<sp />p_qy,<sp />p_gy);<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />(y2-y1)<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="414"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />Cy_Crypto_Core_EC_SubMod(base,<sp />p_s,<sp />p_qx,<sp />p_gx);<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />(x2-x1)<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="415"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />Cy_Crypto_Core_EC_DivMod(base,<sp />p_s,<sp />dividend,<sp />p_s,<sp />bitsize);<sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />s<sp />=<sp />(y2-y1)/(x2-x1)<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="416"><highlight class="normal" /></codeline>
<codeline lineno="417"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />Cy_Crypto_Core_EC_SquareMod<sp />(base,<sp />p_s,<sp />p_s,<sp />bitsize);<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />s^2<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="418"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />Cy_Crypto_Core_EC_SubMod<sp /><sp /><sp /><sp />(base,<sp />p_s,<sp />p_s,<sp />p_gx);<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />s^2<sp />-<sp />x1<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="419"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />Cy_Crypto_Core_EC_SubMod<sp /><sp /><sp /><sp />(base,<sp />p_s,<sp />p_s,<sp />p_qx);<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />s^2<sp />-<sp />x1<sp />-<sp />x2<sp />which<sp />is<sp />Px<sp />mod<sp />n<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="420"><highlight class="normal" /></codeline>
<codeline lineno="421"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />CY_CRYPTO_VU_FREE_MEM(base,<sp />CY_CRYPTO_VU_REG_BIT(p_o));</highlight></codeline>
<codeline lineno="422"><highlight class="normal" /></codeline>
<codeline lineno="423"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(<ref kindref="member" refid="group__group__crypto__lld__vu__functions_1ga8e0735e9fc34fe5a31250fd4b63c2d4e">Cy_Crypto_Core_Vu_IsRegEqual</ref>(base,<sp />p_s,<sp />p_r))</highlight></codeline>
<codeline lineno="424"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="425"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />*stat<sp />=<sp />1u;</highlight></codeline>
<codeline lineno="426"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="427"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">else</highlight><highlight class="normal" /></codeline>
<codeline lineno="428"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="429"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />*stat<sp />=<sp />0u;</highlight></codeline>
<codeline lineno="430"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="431"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="432"><highlight class="normal" /></codeline>
<codeline lineno="433"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />CY_CRYPTO_VU_FREE_MEM(base,<sp />mallocMask);</highlight></codeline>
<codeline lineno="434"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="435"><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="436"><highlight class="normal" /></codeline>
<codeline lineno="437"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">return</highlight><highlight class="normal"><sp />(tmpResult);</highlight></codeline>
<codeline lineno="438"><highlight class="normal">}</highlight></codeline>
<codeline lineno="439"><highlight class="normal" /></codeline>
<codeline lineno="440"><highlight class="normal" /><highlight class="preprocessor">#if<sp />defined(__cplusplus)</highlight><highlight class="normal" /></codeline>
<codeline lineno="441"><highlight class="normal">}</highlight></codeline>
<codeline lineno="442"><highlight class="normal" /><highlight class="preprocessor">#endif</highlight><highlight class="normal" /></codeline>
<codeline lineno="443"><highlight class="normal" /></codeline>
<codeline lineno="444"><highlight class="normal" /><highlight class="preprocessor">#endif<sp /></highlight><highlight class="comment">/*<sp />CY_IP_MXCRYPTO<sp />*/</highlight><highlight class="preprocessor" /><highlight class="normal" /></codeline>
<codeline lineno="445"><highlight class="normal" /></codeline>
<codeline lineno="446"><highlight class="normal" /></codeline>
<codeline lineno="447"><highlight class="normal" /><highlight class="comment">/*<sp />[]<sp />END<sp />OF<sp />FILE<sp />*/</highlight><highlight class="normal" /></codeline>
    </programlisting>
    <location file="/var/tmp/gitlab-runner1/builds/7e5c9300/0/repo/psoc6pdl/drivers/source/cy_crypto_core_ecc_ecdsa.c" />
  </compounddef>
</doxygen>